import { install } from './install'
import { inBrowser } from './util/dom'

export default class VueSideEffect {
  constructor (options = {}) {
    // asserting codes are spooned from https://github.com/gaearon/react-side-effect
    if (typeof options.reducePropsToState !== 'function') {
      throw new Error('Expected reducePropsToState to be a function.');
    }
    if (typeof options.handleStateChangeOnClient !== 'function') {
      throw new Error('Expected handleStateChangeOnClient to be a function.');
    }
    if (typeof options.mapStateOnServer !== 'undefined' &&
          typeof options.mapStateOnServer !== 'function') {
     throw new Error('Expected mapStateOnServer to either be undefined or a function.');
    }
    this.options = options
  }
}


VueSideEffect.install = install

if (inBrowser && window.Vue) {
  window.Vue.use(VueSideEffect)
}
