import { inBrowser } from './util/dom'

export function install (Vue) {
  if (install.installed) return
  install.installed = true

  let mountedInstances = []
  let state

  function emitChange(sideEffect) {
    const options = sideEffect.options
    state = options.reducePropsToState(mountedInstances.map(function (instance) {
      // TODO pick props only
      // return instance.props
      return instance
    }))

    if (inBrowser) {
      options.handleStateChangeOnClient(state)
    } /*else if (options.mapStateOnServer) {
      state = options.mapStateOnServer(state)
    }*/
  }

  // TODO reseach how to mixin only sideEffect component use `beforeCreate`
  Vue.mixin({
    beforeDestroy () {
      const sideEffect = this.$options.sideEffect
      if (sideEffect) {
        const index = mountedInstances.indexOf(this)
        mountedInstances.splice(index, 1)
        emitChange(sideEffect)
      }
    },
    beforeMount () {
      const sideEffect = this.$options.sideEffect
      if (sideEffect) {
        mountedInstances.push(this)
        emitChange(sideEffect)
      }
    },
    updated () {
      const sideEffect = this.$options.sideEffect
      if (sideEffect) {
        emitChange(sideEffect)
      }
    }
  })
}
